#pragma once

#include <map>
#include <string>

namespace inaf::oasbo::Configurators {

class BaseConfigurator{
protected:
	std::map<std::string,std::string> config;

public:
	virtual int readConfigFromSource() = 0;
	virtual int readConfigFromSource(std::string target) = 0;
	virtual int pushConfigToSource() = 0;
	virtual int pushConfigToSource(std::string target) = 0;
	virtual int insert(std::map<std::string, std::string>, std::string target) = 0;
	virtual std::map<std::string, std::string> getConfig() {return this->config;}

	std::string toString(){
		std::string ret = "";
		for( const std::pair<std::string, std::string> n : config) {
			ret += n.first + " : " + n.second + "\n";
		}
		return ret;
	}

	virtual ~BaseConfigurator() = default;

};
}
