/*
 *
 *  Created on: Mar 1, 2021
 *      Author: astrisw
 *
 */

#pragma once
#include <string>
#include <Base_Packet.h>
#include <map>

namespace inaf::oasbo::PacketMonitors{

class BasePacketMonitor{
protected:
	std::map<std::string, std::string> stats;
public:
	virtual void monit(PacketLib::BasePacket &) = 0;
	virtual void printStats()=0;
	virtual void reset() = 0;
    virtual std::map<std::string, std::string> getStatsMap() const { return stats;}
    std::optional<std::string> getStat(std::string stat) const {
		try {
			return this->stats.at(stat);
		} catch (const std::out_of_range &) {
			return std::nullopt;
		}
    }

	virtual ~BasePacketMonitor() = default;


};
}

